// // See richardtape.com/?p=348
//
// const { assign } = lodash;
// const { __ } = wp.i18n;
// const { Fragment } = wp.element;
// const { addFilter } = wp.hooks;
// const { TextControl, PanelBody } = wp.components;
// const { createHigherOrderComponent } = wp.compose;
// const { InspectorControls } = wp.editor;
//
//
// /**
//  * Override the default edit UI to include a new block inspector control for
//  * adding our custom control.
//  *
//  * @param {function|Component} BlockEdit Original component.
//  *
//  * @return {string} Wrapped component.
//  */
// export const addZotpressBlockControls = createHigherOrderComponent( ( BlockEdit ) => {
//
//     return ( props ) => {
//
//         // If this block supports scheduling and is currently selected, add our UI
//         if ( isValidBlockType( props.name ) && props.isSelected ) {
//             return (
//                 <Fragment>
//                     <BlockEdit { ...props } />
//                     <InspectorControls>
//                         <PanelBody title={ __( 'Zotpress Reference' ) }>
//                             <TextControl
//                                 label={ __( 'Zotpress Reference 2' ) }
//                                 help={ __( 'Some help text for my custom control.' ) }
//                                 value={ props.attributes.scheduledStart || '' }
//                                 onChange={ ( nextValue ) => {
//                                     props.setAttributes( {
//                                         scheduledStart: nextValue,
//                                     } );
//                                 } } />
//                         </PanelBody>
//                     </InspectorControls>
//                 </Fragment>
//             );
//         }
//
//         return <BlockEdit { ...props } />;
//     };
// }, 'addZotpressBlockControls' );
//
// addFilter( 'editor.BlockEdit', 'zotpress/zotpress-reference', addZotpressBlockControls );
//
//
//
//
// /**
//  * Is the passed block name one which supports our custom field?
//  *
//  * @param {string} name The name of the block.
//  */
// function isValidBlockType( name ) {
//
//     const validBlockTypes = [
//         'core/paragraph',
//         'core/shortcode',
//         'core/html',
//     ];
//
//     return validBlockTypes.includes( name );
//
// }// end isValidBlockType()
//
//
//
//
// /**
//  * Filters registered block settings, extending attributes with our custom data.
//  *
//  * @param {Object} settings Original block settings.
//  *
//  * @return {Object} Filtered block settings.
//  */
// export function addAttribute( settings ) {
//
// 	// If this is a valid block
// 	if ( isValidBlockType( settings.name ) ) {
//
// 		// Use Lodash's assign to gracefully handle if attributes are undefined
// 		settings.attributes = assign( settings.attributes, {
// 			scheduledStart: {
// 				type: 'string',
// 			},
// 		} );
// 	}
//
// 	return settings;
//
// }// end addAttribute()
//
// /**
//  * Override props assigned to save component to inject our custom data.
//  * This is only done if the component is a valid block type.
//  *
//  * @param {Object} extraProps Additional props applied to save element.
//  * @param {Object} blockType  Block type.
//  * @param {Object} attributes Current block attributes.
//  *
//  * @return {Object} Filtered props applied to save element.
//  */
// export function addSaveProps( extraProps, blockType, attributes ) {
//
// 	// If the current block is valid, add our prop.
// 	if ( isValidBlockType( blockType.name ) ) {
// 		extraProps.scheduledStart = attributes.scheduledStart;
// 	}
//
// 	return extraProps;
//
// }// end addSaveProps()
//
// addFilter( 'blocks.registerBlockType', 'zotpress/add-attr', addAttribute );
// addFilter( 'blocks.getSaveContent.extraProps', 'zotpress/add-props', addSaveProps );
//






// TODO: Start from here
// ( function( wp ) {
//
//     // import icons from zp.ZOTPRESS_PLUGIN_URL + 'js/zotpress.icon.js'
//
//     var registerPlugin = wp.plugins.registerPlugin;
//     var PluginSidebar = wp.editPost.PluginSidebar;
//     var el = wp.element.createElement;
//
//     registerPlugin( 'zotpress-gutenberg-sidebar', {
//         render: function() {
//             return el( PluginSidebar,
//                 {
//                     name: 'zotpress-gutenberg-sidebar',
//                     // icon: 'admin-pin', // icons.zotpress
//                     title: 'Zotpress',
//                 },
//                 'Meta field'
//             );
//         },
//     } );
// } )( window.wp );

//
// ( function( plugins, editPost, element, components, data, compose ) {
//
// 	const el = element.createElement;
//
// 	const { Fragment } = element;
// 	const { registerPlugin } = plugins;
// 	const { PluginSidebar, PluginSidebarMoreMenuItem } = editPost;
// 	const { PanelBody, TextControl, TextareaControl, CheckboxControl } = components;
// 	const { withSelect, withDispatch } = data;
//
//
// 	const MetaTextControl = ...
// 	const MetaTextareaControl = ...
// 	const MetaCheckboxControl = ...
//
// 	registerPlugin(
// 		...
// 	);
//
// } )(
// 	window.wp.plugins,
// 	window.wp.editPost,
// 	window.wp.element,
// 	window.wp.components,
// 	window.wp.data,
// 	window.wp.compose
// );
//
// registerPlugin( 'zotpress-sidebar', {
// 	render: function() {
// 		return el( Fragment, {},
// 			el( PluginSidebarMoreMenuItem,
// 				{
// 					target: 'zotpress-sidebar',
// 					icon: 'admin-post',
// 				},
// 				'Zotpress Reference'
// 			),
// 			el( PluginSidebar,
// 				{
// 					name: 'zotpress-sidebar',
// 					icon: 'admin-post',
// 					title: 'Zotpress Reference',
// 				},
// 				el( PanelBody, {},
// 					// Field 1
// 					el( MetaTextControl,
// 						{
// 							metaKey: 'misha_plugin_seo_title',
// 							title : 'Title',
// 						}
// 					),
// 					// Field 2
// 					el( MetaTextareaControl,
// 						{
// 							metaKey: 'misha_plugin_seo_description',
// 							title : 'Description',
// 						}
// 					),
// 					// Field 3
// 					el( MetaCheckboxControl,
// 						{
// 							metaKey: 'misha_plugin_seo_robots',
// 							title : 'Hide from search engines',
// 						}
// 					),
// 				)
// 			)
// 		);
// 	}
// } );
